OUTPUT_FORMAT("coff-h8300")
OUTPUT_ARCH(h8300h)
ENTRY("_start")
MEMORY
{
	vectors      : org = 0x0000, len = 0x0400
	sysprm       : org = 0x0400, len = 0x0400
	ptext        : org = 0x0800, len = 0x0400
	rom          : org = 0x0c00, len = 0x7400
	ram          : org = 0xf780, len = 0x0600
	stack        : org = 0xff70, len = 0x0010
}
SECTIONS 				
{ 					
.vectors : {
	/* Use something like this to place a specific function's address
	   into the vector table.  */
	SHORT(ABSOLUTE(_start))		/* 0x00 Reset vector */
	SHORT(ABSOLUTE(_start))		/* 0x02 Reserved */
	SHORT(ABSOLUTE(_start))		/* 0x04 Reserved */
	SHORT(ABSOLUTE(_start))		/* 0x06 Reserved */
	SHORT(ABSOLUTE(_start))		/* 0x08 Reserved */
	SHORT(ABSOLUTE(_start))		/* 0x0a Reserved */
	SHORT(ABSOLUTE(_start))		/* 0x0c Reserved */

	SHORT(ABSOLUTE(_int_nmi))	/* 0x0e NMI */
	SHORT(ABSOLUTE(_int_trap0))	/* 0x10 TRAP 0*/
	SHORT(ABSOLUTE(_int_trap1))	/* 0x12 TRAP 1*/
	SHORT(ABSOLUTE(_int_trap2))	/* 0x14 TRAP 2*/
	SHORT(ABSOLUTE(_int_trap3))	/* 0x16 TRAP 3*/
	SHORT(ABSOLUTE(_int_break))	/* 0x18 Address break */
	SHORT(ABSOLUTE(_int_sleep))	/* 0x1a Direct by Sleep */

	SHORT(ABSOLUTE(_int_irq0))	/* 0x1c */
	SHORT(ABSOLUTE(_int_irq1))	/* 0x1e */
	SHORT(ABSOLUTE(_int_irq2))	/* 0x20 */
	SHORT(ABSOLUTE(_int_irq3))	/* 0x22 */
	SHORT(ABSOLUTE(_int_wkp))	/* 0x24 */

	SHORT(ABSOLUTE(_int_ovia))	/* 0x26 Timer A Overflow */
	SHORT(ABSOLUTE(_start))		/* 0x28 Reserved */

	SHORT(ABSOLUTE(_int_tmiw))	/* 0x2a Timer W capture/compare/ovi */
	SHORT(ABSOLUTE(_int_tmiv))	/* 0x2c Timer V compare/ovi */
	SHORT(ABSOLUTE(_int_sci))	/* 0x2e SCI interrupt */
	SHORT(ABSOLUTE(_int_iic))	/* 0x30 IIC Interrupt */
	SHORT(ABSOLUTE(_int_adc))	/* 0x32 ADC Interrupt */

        }  > vectors

.sysprm : {
	*(.sysprm)
	} > sysprm

.ptext : {
	*(.ptext)
	} > ptext

.text : {
	*(.text) 				
	*(.strings)
	*(.rodata) 				
   	 _etext = . ; 
	} > rom
.tors : {
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	___dtors_end = . ;
	}  > rom
.data : AT ( ADDR(.tors) + SIZEOF(.tors) ){
	___data = . ;
	*(.data)
	*(.tiny)
	 _edata = .;
	} > rom

.vtext : {
	*(.vtext)
	} > vtext

.bss : AT ( LOADADDR(.data) + SIZEOF(.data) ) {
	 _bss_start = . ;
	*(.bss)
	*(COMMON)
	 _end = . ;  
	}  >ram
.stack : {
	 _stack = . ; 
	*(.stack)
	}  > stack
.stab 0 (NOLOAD) : {
	[ .stab ]
	}
.stabstr 0 (NOLOAD) : {
	[ .stabstr ]
	}
}
