/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    monitor.c : $B%^%k%A%U%!%s%3%s%H%m!<%i(B $B%b%K%?%b%8%e!<%k(B       ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
/*
 *  Version 1.0 : 2005.11.2    by tutti
 */
#include	"fancnt.h"
#include	"h8_3694.h"

/************************************************************************
 *    $B@k8@(B                                                              *
 ************************************************************************/
/**** $B%b%K%?BP>]30ItJQ?t(B ****/
extern sysParam		sysp;
extern unsigned char	chmask[4];

/**** $B4X?t@k8@(B ****/
void	execMonitor(unsigned int *, int *, unsigned char *);
void	rpmDataCnv(char *, unsigned int);
void	thDataCnv(char *, int);
void	dutyDataCnv(char *, unsigned char);
int	sendDuty(int);
int	sendParam(int);
int	sendChStat(int);
int	sendThStat(int);
int	sendRPM(int);
int	sendFanType(int);

/************************************************************************
 *    $BO"B3%G!<%?%b%K%?4X?t(B                                              *
 ************************************************************************/
/*
 * $B%b%K%?%G!<%?%U%)!<%^%C%H(B
 *
 * MxRxxxxTxxxDxxx\n\r : 16Byte
 *  | --+- -+ -+-
 *  |   |   |  +----------------- $B8=:_$N%G%e!<%F%#Hf(B 3$B7e(B[%]
 *  |   |   +-------------------- $B8=:_$N29EY(B
 *  |   +------------------------ $B8=:_$N%U%!%s2sE>?t(B
 *  +---------------------------- $B%?!<%2%C%H%A%c%s%M%k(B
 */
void
execMonitor(unsigned int rpm[4], int thermo[4], unsigned char chduty[4])
{
    int		i;
    char	buf[20];

    buf[0] = 'M';
    buf[2] = 'R';
    buf[7] = 'T';
    buf[11] = 'D';
    for(i=0; i<4; i++) {
        buf[1] = 0x30 + i;
        rpmDataCnv(&(buf[3]), rpm[i]);
        thDataCnv(&(buf[8]), thermo[i]);
        dutyDataCnv(&(buf[12]), chduty[i]);
        buf[15] = '\n';
        buf[16] = '\r';
        buf[17] = '\0';
        puts(buf);
    }
}

/**** $B2sE>?t"*(B4$B7e?t;z$N(Bascii$B%3!<%IJQ49(B ****/
void
rpmDataCnv(char *buf, unsigned int rpm)
{
    int		data;
    char	col1, col2, col3, col4;

    if (rpm > 9999)	data = 9999;
    else		data = (int)rpm;
    col4 = (char)(data / 1000);			/* 4$B7eL\(B */
    data = data - ((int)col4 * 1000);
    col3 = (char)(data / 100);			/* 3$B7eL\(B */
    data = data - ((int)col3 * 100);
    col2 = (char)(data / 10);			/* 2$B7eL\(B */
    col1 = (char)(data - (col2 * 10));		/* 1$B7eL\(B */

    buf[0] = 0x30 + col4;
    buf[1] = 0x30 + col3;
    buf[2] = 0x30 + col2;
    buf[3] = 0x30 + col1;
}

/**** $B29EY"*(B3$B7e?t;z$N(Bascii$B%3!<%IJQ49(B ****/
void
thDataCnv(char *buf, int thermo)
{
    char	col1, col2, col3;
    
    col3 = (char)(thermo / 100);
    thermo = thermo - ((int)col3 * 100);
    col2 = (char)(thermo / 10);
    col1 = (char)(thermo - (col2 * 10));
    buf[0] = 0x30 + col3;
    buf[1] = 0x30 + col2;
    buf[2] = 0x30 + col1;
}

/**** Duty$BHf"*(B3$B7e?t;z$N(Bascii$B%3!<%IJQ49(B ****/
void
dutyDataCnv(char *buf, unsigned char duty)
{
    char	col1, col2, col3;

    col3 = (char)(duty /100);
    duty = duty - ((int)col3 * 100);
    col2 = (char)(duty / 10);
    col1 = (char)(duty - (col2 * 10));
    buf[0] = 0x30 + col3;
    buf[1] = 0x30 + col2;
    buf[2] = 0x30 + col1;
}

/************************************************************************
 *    $B%?!<%2%C%H%A%c%s%M%k$N%G%e!<%F%#HfAw?.(B                            *
 ************************************************************************/
int
sendDuty(int ch)
{
    char	buf[16];

    buf[0] = 'U';
    buf[1] = 0x30 + ch;
    buf[2] = 'D';
    dutyDataCnv(&(buf[3]), sysp.chd[ch]);
    buf[6] = 'D';
    dutyDataCnv(&(buf[7]), sysp.crd[ch]);
    buf[10] = '\n';
    buf[11] = '\r';
    buf[12] = '\0';
    puts(buf);

    return 1;
}

/************************************************************************
 *    $B%?!<%2%C%H%A%c%s%M%k$N29EY78?tAw?.(B                                *
 ************************************************************************/
int
sendParam(int ch)
{
    int		d;
    char	col1, col2, buf[16];
    
    d = (int)sysp.ka[ch];
    col2 = (char)(d / 10);
    col1 = (char)(d - (col2 * 10));
    buf[0] = 'K';
    buf[1] = 0x30 + ch;
    buf[2] = col2 + 0x30;
    buf[3] = col1 + 0x30;
    
    d = (int)sysp.kb[ch];
    col2 = (char)(d / 10);
    col1 = (char)(d - (col2 * 10));
    buf[4] = col2 + 0x30;
    buf[5] = col1 + 0x30;
    
    d = (int)sysp.kc[ch];
    col2 = (char)(d / 10);
    col1 = (char)(d - (col2 * 10));
    buf[6] = col2 + 0x30;
    buf[7] = col1 + 0x30;
    
    d = (int)sysp.kd[ch];
    col2 = (char)(d / 10);
    col1 = (char)(d - (col2 * 10));
    buf[8] = col2 + 0x30;
    buf[9] = col1 + 0x30;
    buf[10] = '\n';
    buf[11] = '\r';
    buf[12] = '\0';
    puts(buf);

    return 1;
}

/************************************************************************
 *    $B%?!<%2%C%H%A%c%s%M%k$N2TF/%9%F!<%?%9Aw?.(B                          *
 ************************************************************************/
int
sendChStat(int ch)
{
    char	buf[8];
    
    buf[0] = 'N';
    buf[1] = 0x30 + ch;
    buf[2] = 'C';
    if (sysp.onch & chmask[ch])	buf[3] = '1';
    else			buf[3] = '0';
    buf[4] = '\n';
    buf[5] = '\r';
    buf[6] = '\0';

    puts(buf);

    return 1;
}

/************************************************************************
 *    $B%5!<%_%9%?$NM-8z%9%F!<%?%9Aw?.(B                                    *
 ************************************************************************/
int
sendThStat(int ch)
{
    char	buf[8];
    
    buf[0] = 'T';
    buf[1] = 0x30 + ch;
    buf[2] = 'C';
    if (sysp.onth & chmask[ch])	buf[3] = '1';
    else			buf[3] = '0';
    buf[4] = '\n';
    buf[5] = '\r';
    buf[6] = '\0';
    puts(buf);

    return 1;
}

/************************************************************************
 *    $B%G%e!<%F%#Hf8GDj%9%F!<%?%9Aw?.(B                                    *
 ************************************************************************/
int
sendFixStat(int ch)
{
    char	buf[12];
    
    buf[0] = 'F';
    buf[1] = 0x30 + ch;
    buf[2] = 'C';
    if (sysp.fxch & chmask[ch])	buf[3] = '1';
    else			buf[3] = '0';
    buf[4] = 'D';
    dutyDataCnv(&(buf[5]), sysp.fxd[ch]);
    buf[8] = '\n';
    buf[9] = '\r';
    buf[10] = '\0';
    puts(buf);

    return 1;
}

/************************************************************************
 *    $B%?!<%2%C%H%A%c%s%M%k$N:G>/(Bduty$BHfAw?.(B                              *
 ************************************************************************/
int
sendMinDuty(int ch)
{
    char	buf[10];
    
    buf[0] = 'I';
    buf[1] = 0x30 + ch;
    buf[2] = 'M';
    dutyDataCnv(&(buf[3]), sysp.mnd[ch]);
    buf[6] = '\n';
    buf[7] = '\r';
    buf[8] = '\0';
    puts(buf);

    return 1;
}

/************************************************************************
 *    $B2sE>?t>pJs$NAw?.(B                                                  *
 ************************************************************************/
int
sendRPM(int ch)
{
    char	buf[12];
    
    buf[0] = 'R';
    buf[1] = 0x30 + ch;
    buf[2] = 'F';
    if (sysp.rpmf & chmask[ch])	buf[3] = '1';
    else			buf[3] = '0';
    rpmDataCnv(&(buf[4]), sysp.rpm[ch]);
    buf[8] = '\n';
    buf[9] = '\r';
    buf[10] = '\0';
    puts(buf);

    return 1;
}

int
sendFanType(int ch)
{
    char	buf[8];
    
    buf[0] = 'P';
    buf[1] = 0x30 + ch;
    buf[3] = '\n';
    buf[4] = '\r';
    buf[5] = '\0';
    switch(ch) {
    case 0:
        if ((sysp.fantype & 0x03) == 0) buf[2] = '0';
        else				buf[2] = '1';
        puts(buf);
        break;
    case 1:
        if ((sysp.fantype & 0x0c) == 0) buf[2] = '0';
        else				buf[2] = '1';
        puts(buf);
        break;
    case 2:
        if ((sysp.fantype & 0x30) == 0) buf[2] = '0';
        else				buf[2] = '1';
        puts(buf);
        break;
    case 3:
        if ((sysp.fantype & 0xc0) == 0) buf[2] = '0';
        else				buf[2] = '1';
        puts(buf);
        break;
    }
    return 1;
}

/************************************************************************
 *    $B%a%b%j%@%s%W(B                                                      *
 ************************************************************************/
int
putcBlock(unsigned char c)
{
    int		i, rtn;

    rtn = 0;
    for(i=0; i<0xffff; i++) {
        rtn = putc(c, STDOUT);
        if (rtn)	break;
    }
    return rtn;
}

void
word2hex(unsigned int d, unsigned char *buf)
{
    unsigned int	n;
    unsigned char	c;

    n = (d & 0xf000) >> 12;
    if (n > 9)	c = 'a' + (n - 10);
    else	c = '0' + n;
    buf[0] = c;
    n = (d & 0x0f00) >> 8;
    if (n > 9)	c = 'a' + (n - 10);
    else	c = '0' + n;
    buf[1] = c;
    n = (d & 0x00f0) >> 4;
    if (n > 9)	c = 'a' + (n - 10);
    else	c = '0' + n;
    buf[2] = c;
    n = (d & 0x000f);
    if (n > 9)	c = 'a' + (n - 10);
    else	c = '0' + n;
    buf[3] = c;
    buf[4] = '\0';
}

void
byte2hex(unsigned char d, unsigned char *buf)
{
    unsigned int	n;
    unsigned char	c;

    n = (d & 0xf0) >> 4;
    if (n > 9)	c = 'a' + (n - 10);
    else	c = '0' + n;
    buf[0] = c;
    n = (d & 0x0f);
    if (n > 9)	c = 'a' + (n - 10);
    else	c = '0' + n;
    buf[1] = c;
    buf[2] = '\0';
}

unsigned long
hex2word(unsigned char *ptr)
{
    int			i, rtn;
    unsigned char	d;

    rtn = 0;
    for(i=0; i<4; i++) {
        if ((ptr[i] >= '0') && (ptr[i] <= '9'))
            d = ptr[i] - '0';
        else if ((ptr[i] >= 'a') && (ptr[i] <= 'f'))
            d = ptr[i] - 'a' + 10;
        else if ((ptr[i] >= 'A') && (ptr[i] <= 'F'))
            d = ptr[i] - 'A' + 10;
        else
            d = 0;
        rtn = (rtn << 4) + (unsigned int)d;
    }
    return (unsigned long)rtn;
}

unsigned long
hex2byte(unsigned char *ptr)
{
    int			i, rtn;
    unsigned char	d;

    rtn = 0;
    for(i=0; i<2; i++) {
        if ((ptr[i] >= '0') && (ptr[i] <= '9'))
            d = ptr[i] - '0';
        else if ((ptr[i] >= 'a') && (ptr[i] <= 'f'))
            d = ptr[i] - 'a' + 10;
        else if ((ptr[i] >= 'A') && (ptr[i] <= 'F'))
            d = ptr[i] - 'A' + 10;
        else
            d = 0;
        rtn = (rtn << 4) + (unsigned int)d;
    }
    return (unsigned long)rtn;
}

int
memdump(char *cmd)
{
    unsigned long	adr;
    unsigned int	i, n;
    unsigned char	bd, buf[8], *ptr;

    /**** $B%X%C%@I=<((B ****/
    puts("Memory dump\n\r");
    puts("Address: 00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f\n\r");

    /**** $BJ8;zNs"*%"%I%l%9(B ****/
    if ((cmd[1] == 'x') || (cmd[1] == 'X')) {
        ptr = (unsigned char *)hex2word(&(cmd[2]));
    } else {
        ptr = (unsigned char *)hex2word(cmd);
    }

    for(n=0; n<8; n++) {
        /**** $B%"%I%l%9I=<((B ****/
        putcBlock(' ');
        putcBlock('0');
        putcBlock('x');
        adr = (unsigned long)ptr;
        word2hex((unsigned int)adr, buf);
        for(i=0; i<4; i++)	putcBlock(buf[i]);
        putcBlock(':');
        /**** $B%G!<%?I=<((B ****/
        for(i=0; i<16; i++) {
            putcBlock(' ');
            bd = *ptr++;
            byte2hex(bd, buf);
            putcBlock(buf[0]);
            putcBlock(buf[1]);
        }
        putcBlock('\n');
        putcBlock('\r');
    }
}

int
wrtWord(char *cmd)
{
    int			i;
    unsigned int	*ptr;
    unsigned int	dat;
    char		*str;
    char		astr[10], dstr[10];
    
    /**** $BJ8;zNs"*%"%I%l%9(B ****/
    if ((cmd[1] == 'x') || (cmd[1] == 'X')) {
        ptr = (unsigned int *)hex2word(&(cmd[2]));
        str = &(cmd[7]);
        for(i=0; i<6; i++)	astr[i] = cmd[i];
    } else {
        ptr = (unsigned int *)hex2word(cmd);
        str = &(cmd[5]);
        astr[0] = '0';
        astr[1] = 'x';
        for(i=0; i<4; i++)	astr[i+2] = cmd[i];
    }
    astr[6] = '\0';

    /**** $B=q$-9~$_%G!<%?(B ****/
    if ((str[1] == 'x') || (str[1] == 'X')) {
        dat = (unsigned int)hex2word(&(str[2]));
        for(i=0; i<6; i++)	dstr[i] = str[i];
    } else {
        dat = (unsigned int)hex2word(str);
        dstr[0] = '0';
        dstr[1] = 'x';
        for(i=0; i<4; i++)	dstr[i+2] = str[i];
    }
    dstr[6] = '\0';

    /**** $B%G!<%?=q$-9~$_(B ****/
    *ptr = dat;
    puts("Write word data\n\r");
    puts(astr);
    puts("=");
    puts(dstr);
    puts("\n\r");
}

int
wrtByte(char *cmd)
{
    int			i;
    unsigned char	*ptr;
    unsigned char	dat;
    char		*str;
    char		astr[10], dstr[10];
    
    /**** $BJ8;zNs"*%"%I%l%9(B ****/
    if ((cmd[1] == 'x') || (cmd[1] == 'X')) {
        ptr = (unsigned char *)hex2word(&(cmd[2]));
        str = &(cmd[7]);
        for(i=0; i<6; i++)	astr[i] = cmd[i];
    } else {
        ptr = (unsigned char *)hex2word(cmd);
        str = &(cmd[5]);
        astr[0] = '0';
        astr[1] = 'x';
        for(i=0; i<4; i++)	astr[i+2] = cmd[i];
    }
    astr[6] = '\0';

    /**** $B=q$-9~$_%G!<%?(B ****/
    if ((str[1] == 'x') || (str[1] == 'X')) {
        dat = (unsigned char)hex2byte(&(str[2]));
        for(i=0; i<4; i++)	dstr[i] = str[i];
    } else {
        dat = (unsigned char)hex2byte(str);
        dstr[0] = '0';
        dstr[1] = 'x';
        for(i=0; i<2; i++)	dstr[i+2] = str[i];
    }
    dstr[4] = '\0';

    /**** $B%G!<%?=q$-9~$_(B ****/
    *ptr = dat;
    puts("Write byte data\n\r");
    puts(astr);
    puts("=");
    puts(dstr);
    puts("\n\r");
}
    
/* end of file */

