/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    system.c : H8 ӃRg[W[                ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
/*
 * 2005.11.3 : }`t@Rg[pقڊ
 */

#include	"fancnt.h"
#include	"h8_3694.h"

/************************************************************************
 *    ֐錾                                                          *
 ************************************************************************/
/**** ֐錾 ****/
void		init_sys(void);
void		ovia(void);
int		check25msec(void);
int		check100msec(void);
int		check500msec(void);
int		check1000msec(void);
void		tmiv(void);
void		tmiw(void);
void		sci(void);
void		_outc(void);
void		adc(void);
void		startAD(void);
void		stopAD(void);
int		checkAD(void);
unsigned int	getPulseCount(int);

/**** ϐ錾 ****/
extern sysParam	sysp;

/************************************************************************
 *    VXe֐                                                *
 *    System Clock : 20MHz 50nsec                                       *
 *    Timer A : ^Cx[XpC^[o^C}                        *
 *        clk/2048 256 -> 0.050x2048x256 ->  26.2144[msec]              *
 *    Timer V : PWMo͗p                                               *
 *        RyA}b`A,BgpBB0xFFŒ({)BClock=/128  *
 *        Overflow 荞݂TCORA(Duty)XV                          *
 *    Timer W : ]͗pInput Capture (2Pulse/])                 *
 *        1000rpm(16.6 x 2Hz) ` 7200rpm(120 x 2Hz)                     *
 ************************************************************************/
void
init_sys(void)
{
    int			i;
    unsigned char	d;

    /**** ϐ ****/
    sysp.pc[0] = 0;
    sysp.pc[1] = 0;
    sysp.pc[2] = 0;
    sysp.pc[3] = 0;
    sysp.tf = 0;
    sysp.c100m = 0;
    sysp.c500m = 0;
    sysp.c1000m= 0;
    sysp.duty4 = 0;
    
    /**** 샂[h ****/
    SYSCR1 = 0x00;
    SYSCR2 = 0x00;
    MSTCR1 = 0x00;

    /**** ^C}A(^C}A͏ɓA~Ȃj ****/
    TMA = 0x12;		/* 'b0001 0010: 26.2144[msec] C^[o^C} */

    /**** ^C}V(PWMo) ̎_Ń^C}JnADuty 0% ****/
    TCORA = 0x00;	/* Duty 0 */
    TCORB = 0xff;	/* { */
    TCRV0 = 0x11;	/* 'b0001 0001: IRQ֎~, CMPBclear ,1/4clock */
    TCSRV = 0x1a;	/* 'b0001 0110: Flag clear, CMPA->0, CMPB->0 */
    TCRV1 = 0xe2;	/* 'b1110 0011: Trigger off, 1/4clock */

    /**** ^C}W(]) ****/
    TMRW = 0x48;	/* 'b0100 1000: ^C}~,ʏ퓮(PWM,obt@Ȃ)*/
    TCRW = 0x30;	/* 'b0011 0000: FreeRun,/8,OutputLevel 0 */
    TIERW= 0x7f;	/* 'b1111 1111: Overflow,Sch 荞݋ */
    TSRW = 0x00;	/* 'b0000 0000: Status clear */
    TIOR0= 0xee;	/* 'b1100 1100: A, B inputcapture, GbW */
    TIOR1= 0xee;	/* 'b1100 1100: C, D inputcapture, GbW */

    /**** EHb`hbO^C} ****/
    /* gpȂil̂܂܁j */

    /**** IIC ****/
    /* gpȂil̂܂܁j */

    /**** ADϊ ****/
    ADCSR = 0x53;	/* 'b0101 0011: IRQ on, Scan mode AN0-3, AD stop */
    ADCR  = 0x7e;	/* 'b0111 1110: Trigger off */
    
    /**** IO|[g ****/
    PMR1  = 0x02;	/* 'b0000 1110; Txd On, ͔ėpI/O|[g */
    PCUR1 = 0xff;	/* S[qvAbv */
    PCR1  = 0x3f;	/* Sē͒[qiŒlj */
    PDR1  = 0x00;
    PCR2  = 0x04;	/* TxD[q̂ݏo͎w */
    PDR2  = 0xff;
    PMR5  = 0x00;	/* Port5: ėpI/O|[g */
    PCR5  = 0xff;	/* Port5: o̓|[g */
    PDR5  = 0x00;	/* Port5: l0 */
    PCR7  = 0x70;	/* Port7: o(P74 TMOVo */
    PDR7  = 0x8f;	/* Port7: l0 */
    PCR8  = 0x01;	/* Port8: P80̂ݏo̓|[g */
    PDR8  = 0x00;	/* l0 */

    /**** SCI ****/
    SCR3 = 0x00;	/* 'b0000 0000: 8bit PrityȂ 1 Stopbit /1 */
    SMR  = 0x00;	/* 'b0011 0000: Tx/Rx Enable, IRQ Disable */
    BRR  = 10;		/* 57600bps */
    for(i=0; i<0x3000; i++) {;}

    /**** 荞ݐݒ ****/
    /*IEGR1 = 0x70;*/	/* l̂܂ */
    /*IEGR2 = 0xc0;*/	/* l̂܂ */
    IENR1 = 0x50;	/* TimerA 荞݋ */

    /**** VXeݒ芮 ****/
    SCR3 = 0x70;	/* VAʐMJn(MEM荞) */
    d = TMRW | 0x80;
    TMRW = d;		/* Timer W Start */
    startirq();
}

void
resetSys(void)
{
    int		i;

    stopirq();			/* 荞݃}XN */
    
    /**** 샂[h ****/
    /*SYSCR1 = 0x00;*/
    /*SYSCR2 = 0x00;*/
    /*MSTCR1 = 0x00;*/
    TMA = 0x10;			/* Timer A Zbg */
    IRR1 = IRR1 & 0x00;

    TCRV0 = 0x00;		/* Timer V Zbg */
    TCRV1 = 0xe2;
    TCORA = 0xff;
    TCORB = 0xff;
    TCSRV = TCSRV & 0x10;

    TMRW = 0x48;		/* Timer W Zbg */
    TCRW = 0x00;
    TIERW= 0x70;
    TSRW = TSRW & 0x70;
    TIOR0= 0x80;
    TIOR1= 0x80;

    ADCSR = 0x00;		/* ADϊ탊Zbg */
    ADCR  = 0x7e;
    
    SCR3 = 0x00;		/* VA~ */
    for(i=0; i<0x3000; i++) {;}	/* 1bit ԑ҂ */
    BRR  = 10;			/* 57600bpsĐݒ */
    for(i=0; i<0x3000; i++) {;}	/* 1bit ԑ҂ */
    SCR3 = 0x30;		/* VAʐMJn(MEM̂) */
    IENR1 = 0x10;		/* 荞݋֎~ */
    /* IO|[g͂̂܂ */
}

/************************************************************************
 *    Timer A I[o[t[荞                                    *
 *    (26.2144[msec]̊荞)                                       *
 ************************************************************************/
void
ovia(void)
{
    unsigned char	d;
    unsigned int	i, total;

    /**** 荞݃Xe[^X̓ǂݏoƃNA ****/
    d = IRR1 & 0xbf;
    IRR1 = d;

    /**** Ԋ֌WtO̐ݒ ****/
    sysp.tf |= 0x01;
    sysp.c100m++;
    if (sysp.c100m >= 4) {		/* 104.8576msec */
        sysp.tf |= 0x02;
        sysp.c100m = 0;
    }
    sysp.c500m++;
    if (sysp.c500m >= 19) {		/* 498.0736msec */
        sysp.tf |= 0x04;
        sysp.c500m = 0;
        for(i=0; i<4; i++) {
            total = sysp.pnm[2][i] + sysp.pc[i];
            sysp.rpm[i] = total * (60/4);
            sysp.pnm[0][i] = sysp.pnm[1][i];
            sysp.pnm[1][i] = sysp.pnm[2][i];
            sysp.pnm[2][i] = sysp.pc[i];
            sysp.pc[i] = 0;
        }
    }
    
    sysp.c1000m++;
    if (sysp.c1000m >= 38) {		/* 996.1472msec */
        sysp.tf |= 0x08;
        sysp.c1000m = 0;
    }
}

/**** 25msec`FbN ****/
int
check25msec(void)
{
    int		rtn;

    stopirq();
    rtn   = sysp.tf & 0x01;
    sysp.tf = sysp.tf & 0xfe;
    startirq();
    return rtn;
}

/**** 100msec`FbN ****/
int
check100msec(void)
{
    int		rtn;

    stopirq();
    rtn   = sysp.tf & 0x02;
    sysp.tf = sysp.tf & 0xfd;
    startirq();
    return rtn;
}

/**** 500msec`FbN ****/
int
check500msec(void)
{
    int		rtn;

    stopirq();
    rtn   = sysp.tf & 0x04;
    sysp.tf = sysp.tf & 0xfb;
    startirq();
    return rtn;
}

/**** 1000msec`FbN ****/
int
check1000msec(void)
{
    int		rtn;

    stopirq();
    rtn   = sysp.tf & 0x08;
    sysp.tf = sysp.tf & 0xf7;
    startirq();
    return rtn;
}

/************************************************************************
 *    Timer V 荞(PWMf[eB̍XV)                           *
 ************************************************************************/
/**** TimerV Overflow 荞 ****/
void
tmiv(void)
{
    unsigned char	d;
    
    /**** Xe[^X̓ǂݏoƃNA ****/
    d = TCSRV & 0xdf;
    if (sysp.duty4 == 0) {			/**** Duty0% ****/
        TCSRV = (d & 0xf0) | 0x0a;	/* CMPA, CMPB Ƃ0o */
        TCORA = 0x00;
        TCORB = 0xff;
    } else if (sysp.duty4 == 0xff) {		/**** Duty100% ****/
        TCSRV = (d & 0xf0) | 0x05;	/* CMPA, CMPB Ƃ1o */
        TCORA = 0x00;
        TCORB = 0xff;
    } else {				/**** Dutyʏ ****/
        TCSRV = (d & 0xf0) | 0x06;	/* CMPA=1, CMB=0 o */
        TCORA = sysp.duty4;
        TCORB = 0xff;
    }
}

void
setTMOVDuty(unsigned char duty)
{
    unsigned char	d;
    
    sysp.duty4 = duty;
    if (duty == 0) {			/**** Duty0% ****/
        TCSRV = (d & 0xf0) | 0x0a;	/* CMPA, CMPB Ƃ0o */
        TCORA = 0x00;
        TCORB = 0xff;
    } else if (duty == 0xff) {		/**** Duty100% ****/
        TCSRV = (d & 0xf0) | 0x05;	/* CMPA, CMPB Ƃ1o */
        TCORA = 0x00;
        TCORB = 0xff;
    } else {				/**** Dutyʏ ****/
        TCSRV = (d & 0xf0) | 0x06;	/* CMPA=1, CMB=0 o */
        TCORA = duty;
        TCORB = 0xff;
    }
}

/************************************************************************
 *    Timer W 荞                                                  *
 ************************************************************************/
void
tmiw(void)
{
    unsigned char	d;

    /* Xe[^Xǂ݂NA */
    d = TSRW;
    if (d & 0x80) {			/* I[o[t[荞 */
        TSRW = TSRW & 0x7f;
    }
    if (d & 0x08) {			/* Input Capture D 荞 */
        sysp.pc[0] = sysp.pc[0] + 1;
        TSRW = TSRW & 0xf7;
    }
    if (d & 0x04) {			/* Input Capture C 荞 */
        sysp.pc[1] = sysp.pc[1] + 1;
        TSRW = TSRW & 0xfb;
    }
    if (d & 0x02) {			/* Input Capture B 荞 */
        sysp.pc[2] = sysp.pc[2] + 1;
        TSRW = TSRW & 0xfd;
    }
    if (d & 0x01) {			/* Input Capture A 荞 */
        sysp.pc[3] = sysp.pc[3] + 1;
        TSRW = TSRW & 0xfe;
    }
}

unsigned int
getPulseCount(int ch)
{
    unsigned int	rtn;

    stopirq();
    rtn = sysp.pc[ch];
    sysp.pc[ch] = 0;
    startirq();
    return rtn;
}

/************************************************************************
 *    SCI 荞                                                      *
 ************************************************************************/
void
sci(void)
{
    unsigned char	c, d;

    d = SSR;

    if (d & 0x40) {			/* RDRF V[uf[^ */
        c = RDR;
        SSR = d & 0xbf;
        ibufInput(c);
    }
    if (d & 0x20) {			/* OER I[o[G[ */
        SSR = d & 0xdf;
    }
    if (d & 0x10) {			/* t[~OG[ */
        SSR = d & 0xef;
    }
    if (d & 0x08) {			/* peBG[ */
        SSR = d & 0xf7;
    }
    if (d & 0x04) {			/* gX~bgGh */
        SSR = d & 0xfb;
        _outc();
    }
    if (d & 0x03) {			/* ̑G[ */
        SSR = d & 0xfc;
    }
}

void
_outc(void)
{
    char	buf[2];

    if (obufOutput(buf) == 0) {
        sysp.sending = 0;
        SCR3 = 0x70;
    } else {
        TDR = buf[0];
        SSR = SSR & 0x7f;
        sysp.sending = 1;
    }
    return;
}

void
dbgout(unsigned char c)
{
    unsigned char	s;
    
    while(1) {
        s = asmReadByte(0xffac);
        if (s & 0x04) {
            TDR = c;
            SSR = SSR & 0x7f;
            break;
        }
    }
}

/************************************************************************
 *    ADϊ ֐                                                     *
 ************************************************************************/
/**** ADI荞 ****/
void
adc(void)
{
    unsigned char	d;
    
    d = ADCSR & 0x1f;		/* scan mode ADϊ̒~ */
    ADCSR = d;
}

/**** ADϊJn ****/
void
startAD(void) 
{
    unsigned char	d;

    d = ADCSR | 0x60;		/* scan mode ADϊ̊Jn */
    ADCSR = d;
}

/**** ADϊ~ ****/
void
stopAD(void)
{
    unsigned char	d;

    d = ADCSR & 0xdf;		/* scan mode ADϊ̒~ */
    ADCSR = d;
}

/**** ADϊs`FbN ****/
int
checkAD(void)
{
    unsigned char	d;

    d = ADCSR;
    ADCSR = d & 0x7f;
    return (d & 0x80);
}

/************************************************************************
 *    ̑e荞݊֐                                              *
 ************************************************************************/
int nmi()	{ ; }
int trap0()	{ while(1); }
int trap1()	{ while(1); }
int trap2()	{ while(1); }
int trap3()	{ while(1); }
int adr_break()	{ while(1); }
int sleep()	{ while(1); }
int irq0()	{ ; }
int irq1()	{ ; }
int irq2()	{ ; }
int irq3()	{ ; }
int irq4()	{ ; }
int wakeup()	{ ; }
int iic()	{ ; }

/* end of file */

